Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_dialog.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_dialog.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_dialog.c	(revision 789)
@@ -70,5 +70,5 @@
 	return PJ_ENOMEM;
 
-    dlg = pj_pool_zalloc(pool, sizeof(pjsip_dialog));
+    dlg = (pjsip_dialog*)pj_pool_zalloc(pool, sizeof(pjsip_dialog));
     PJ_ASSERT_RETURN(dlg != NULL, PJ_ENOMEM);
 
@@ -145,5 +145,6 @@
 	    pjsip_hdr *hdr;
 
-	    hdr = pjsip_parse_hdr(dlg->pool, &param->name, param->value.ptr,
+	    hdr = (pjsip_hdr *)
+		  pjsip_parse_hdr(dlg->pool, &param->name, param->value.ptr,
 				  param->value.slen, NULL);
 	    if (hdr == NULL) {
@@ -290,8 +291,9 @@
      * both local and remote URI.
      */
-    tmp.ptr = pj_pool_alloc(rdata->tp_info.pool, TMP_LEN);
+    tmp.ptr = (char*)pj_pool_alloc(rdata->tp_info.pool, TMP_LEN);
 
     /* Init local info from the To header. */
-    dlg->local.info = pjsip_hdr_clone(dlg->pool, rdata->msg_info.to);
+    dlg->local.info = (pjsip_to_hdr*)
+		      pjsip_hdr_clone(dlg->pool, rdata->msg_info.to);
     pjsip_fromto_hdr_set_from(dlg->local.info);
 
@@ -348,5 +350,6 @@
 
     /* Init remote info from the From header. */
-    dlg->remote.info = pjsip_hdr_clone(dlg->pool, rdata->msg_info.from);
+    dlg->remote.info = (pjsip_from_hdr*)
+		       pjsip_hdr_clone(dlg->pool, rdata->msg_info.from);
     pjsip_fromto_hdr_set_to(dlg->remote.info);
 
@@ -365,5 +368,6 @@
 
     /* Init remote's contact from Contact header. */
-    contact_hdr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
+    contact_hdr = (pjsip_hdr*)
+	          pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
 				     NULL);
     if (!contact_hdr) {
@@ -371,5 +375,6 @@
 	goto on_error;
     }
-    dlg->remote.contact = pjsip_hdr_clone(dlg->pool, contact_hdr);
+    dlg->remote.contact = (pjsip_contact_hdr*)
+			  pjsip_hdr_clone(dlg->pool, contact_hdr);
 
     /* Init remote's CSeq from CSeq header */
@@ -391,5 +396,6 @@
 
     /* Call-ID */
-    dlg->call_id = pjsip_hdr_clone(dlg->pool, rdata->msg_info.cid);
+    dlg->call_id = (pjsip_cid_hdr*)
+		   pjsip_hdr_clone(dlg->pool, rdata->msg_info.cid);
 
     /* Route set. 
@@ -406,5 +412,5 @@
 
 	/* Clone the Record-Route, change the type to Route header. */
-	route = pjsip_hdr_clone(dlg->pool, rr);
+	route = (pjsip_route_hdr*)pjsip_hdr_clone(dlg->pool, rr);
 	pjsip_routing_hdr_set_route(route);
 
@@ -416,5 +422,6 @@
 	if (rr == (pjsip_rr_hdr*)&rdata->msg_info.msg->hdr)
 	    break;
-	rr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_RECORD_ROUTE, rr);
+	rr = (pjsip_route_hdr*)
+	     pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_RECORD_ROUTE, rr);
     }
 
@@ -501,8 +508,9 @@
 
     /* Clone remote target. */
-    dlg->target = pjsip_uri_clone(dlg->pool, first_dlg->target);
+    dlg->target = (pjsip_uri*) pjsip_uri_clone(dlg->pool, first_dlg->target);
 
     /* Clone local info. */
-    dlg->local.info = pjsip_hdr_clone(dlg->pool, first_dlg->local.info);
+    dlg->local.info = (pjsip_fromto_hdr*)
+		      pjsip_hdr_clone(dlg->pool, first_dlg->local.info);
 
     /* Clone local tag. */
@@ -515,8 +523,10 @@
 
     /* Clone local Contact. */
-    dlg->local.contact = pjsip_hdr_clone(dlg->pool, first_dlg->local.contact);
+    dlg->local.contact = (pjsip_contact_hdr*)
+			 pjsip_hdr_clone(dlg->pool, first_dlg->local.contact);
 
     /* Clone remote info. */
-    dlg->remote.info = pjsip_hdr_clone(dlg->pool, first_dlg->remote.info);
+    dlg->remote.info = (pjsip_fromto_hdr*)
+		       pjsip_hdr_clone(dlg->pool, first_dlg->remote.info);
 
     /* Set remote tag from the response. */
@@ -542,5 +552,6 @@
 
     /* Clone Call-ID header. */
-    dlg->call_id = pjsip_hdr_clone(dlg->pool, first_dlg->call_id);
+    dlg->call_id = (pjsip_cid_hdr*)
+		   pjsip_hdr_clone(dlg->pool, first_dlg->call_id);
 
     /* Duplicate Route-Set. */
@@ -550,5 +561,5 @@
 	pjsip_route_hdr *h;
 
-	h = pjsip_hdr_clone(dlg->pool, r);
+	h = (pjsip_route_hdr*) pjsip_hdr_clone(dlg->pool, r);
 	pj_list_push_back(&dlg->route_set, h);
 
@@ -653,5 +664,5 @@
 	pjsip_route_hdr *new_r;
 
-	new_r = pjsip_hdr_clone(dlg->pool, r);
+	new_r = (pjsip_route_hdr*) pjsip_hdr_clone(dlg->pool, r);
 	pj_list_push_back(&dlg->route_set, new_r);
 
@@ -860,5 +871,5 @@
     for (; route != end_list; route = route->next ) {
 	pjsip_route_hdr *r;
-	r = pjsip_hdr_shallow_clone( tdata->pool, route );
+	r = (pjsip_route_hdr*) pjsip_hdr_shallow_clone( tdata->pool, route );
 	pjsip_routing_hdr_set_route(r);
 	pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)r);
@@ -1041,5 +1052,6 @@
 	    /* Add contact header only if one is not present. */
 	    if (pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CONTACT, NULL) == 0) {
-		hdr = pjsip_hdr_clone(tdata->pool, dlg->local.contact);
+		hdr = (pjsip_hdr*) 
+		      pjsip_hdr_clone(tdata->pool, dlg->local.contact);
 		pjsip_msg_add_hdr(tdata->msg, hdr);
 	    }
@@ -1053,5 +1065,5 @@
 					       PJSIP_H_ALLOW, NULL);
 	    if (c_hdr) {
-		hdr = pjsip_hdr_clone(tdata->pool, c_hdr);
+		hdr = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, c_hdr);
 		pjsip_msg_add_hdr(tdata->msg, hdr);
 	    }
@@ -1065,5 +1077,5 @@
 					       PJSIP_H_SUPPORTED, NULL);
 	    if (c_hdr) {
-		hdr = pjsip_hdr_clone(tdata->pool, c_hdr);
+		hdr = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, c_hdr);
 		pjsip_msg_add_hdr(tdata->msg, hdr);
 	    }
@@ -1238,5 +1250,5 @@
 	while (hdr != hdr_list) {
 	    pjsip_msg_add_hdr(tdata->msg,
-			      pjsip_hdr_clone(tdata->pool, hdr));
+			      (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, hdr));
 	    hdr = hdr->next;
 	}
@@ -1387,5 +1399,5 @@
 	    if (hdr->type == PJSIP_H_RECORD_ROUTE) {
 		pjsip_route_hdr *r;
-		r = pjsip_hdr_clone(dlg->pool, hdr);
+		r = (pjsip_route_hdr*) pjsip_hdr_clone(dlg->pool, hdr);
 		pjsip_routing_hdr_set_route(r);
 		pj_list_push_back(&dlg->route_set, r);
@@ -1396,8 +1408,10 @@
 	 * field of the response.
 	 */
-	contact = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
+	contact = (pjsip_contact_hdr*) 
+		  pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
 				     NULL);
 	if (contact) {
-	    dlg->remote.contact = pjsip_hdr_clone(dlg->pool, contact);
+	    dlg->remote.contact = (pjsip_contact_hdr*)
+				  pjsip_hdr_clone(dlg->pool, contact);
 	    dlg->target = dlg->remote.contact->uri;
 	}
@@ -1414,8 +1428,10 @@
 	pjsip_contact_hdr *contact;
 
-	contact = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
+	contact = (pjsip_contact_hdr*) 
+		  pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
 				     NULL);
 	if (contact) {
-	    dlg->remote.contact = pjsip_hdr_clone(dlg->pool, contact);
+	    dlg->remote.contact = (pjsip_contact_hdr*) 
+				  pjsip_hdr_clone(dlg->pool, contact);
 	    dlg->target = dlg->remote.contact->uri;
 	}
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_endpoint.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_endpoint.c	(revision 789)
@@ -144,5 +144,6 @@
 static int cmp_mod_name(void *name, const void *mod)
 {
-    return pj_stricmp(name, &((pjsip_module*)mod)->name);
+    return pj_stricmp((pj_str_t*)name, 
+		      (const pj_str_t*)&((pjsip_module*)mod)->name);
 }
 
@@ -401,5 +402,5 @@
 
     /* Create endpoint. */
-    endpt = pj_pool_zalloc(pool, sizeof(*endpt));
+    endpt = (pjsip_endpoint*) pj_pool_zalloc(pool, sizeof(*endpt));
     endpt->pool = pool;
     endpt->pf = pf;
@@ -591,4 +592,5 @@
     /* timeout is 'out' var. This just to make compiler happy. */
     pj_time_val timeout = { 0, 0};
+    pj_time_val *p_timeout;
 
     PJ_LOG(6, (THIS_FILE, "pjsip_endpt_handle_events()"));
@@ -612,6 +614,12 @@
     }
 
+    /* Timer heap may return PJ_MAXINT32 when it has no entries */
+    if (timeout.sec == PJ_MAXINT32 || timeout.msec == PJ_MAXINT32)
+	p_timeout = NULL;
+    else
+	p_timeout = &timeout;
+
     /* Poll ioqueue. */
-    if (pj_ioqueue_poll( endpt->ioqueue, &timeout) < 0) {
+    if (pj_ioqueue_poll( endpt->ioqueue, p_timeout) < 0) {
 	pj_thread_sleep(1);
 	return pj_get_netos_error();
@@ -676,6 +684,6 @@
 	pj_bool_t mismatch = PJ_FALSE;
 	if (port == 0) {
-	    int type;
-	    type = rdata->tp_info.transport->key.type;
+	    pjsip_transport_type_e type;
+	    type = (pjsip_transport_type_e) rdata->tp_info.transport->key.type;
 	    port = pjsip_transport_get_default_port_for_type(type);
 	}
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_msg.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_msg.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_msg.c	(revision 789)
@@ -238,5 +238,5 @@
 PJ_DEF(pjsip_msg*) pjsip_msg_create( pj_pool_t *pool, pjsip_msg_type_e type)
 {
-    pjsip_msg *msg = pj_pool_alloc(pool, sizeof(pjsip_msg));
+    pjsip_msg *msg = (pjsip_msg *) pj_pool_alloc(pool, sizeof(pjsip_msg));
     pj_list_init(&msg->hdr);
     msg->type = type;
@@ -248,5 +248,5 @@
 				   pjsip_hdr_e hdr_type, const void *start)
 {
-    const pjsip_hdr *hdr=start, *end=&msg->hdr;
+    const pjsip_hdr *hdr=(const pjsip_hdr *)start, *end=&msg->hdr;
 
     if (hdr == NULL) {
@@ -264,5 +264,5 @@
 					   const void *start)
 {
-    const pjsip_hdr *hdr=start, *end=&msg->hdr;
+    const pjsip_hdr *hdr=(const pjsip_hdr *)start, *end=&msg->hdr;
 
     if (hdr == NULL) {
@@ -284,5 +284,5 @@
 				         pjsip_hdr_e hdr_type, void *start)
 {
-    pjsip_hdr *hdr = pjsip_msg_find_hdr(msg, hdr_type, start);
+    pjsip_hdr *hdr = (pjsip_hdr *)pjsip_msg_find_hdr(msg, hdr_type, start);
     if (hdr) {
 	pj_list_erase(hdr);
@@ -316,5 +316,5 @@
 
 	/* Add URI */
-	uri = pjsip_uri_get_uri(msg->line.req.uri);
+	uri = (pjsip_uri*) pjsip_uri_get_uri(msg->line.req.uri);
 	len = pjsip_uri_print( PJSIP_URI_IN_REQ_URI, uri, p, end-p);
 	if (len < 1)
@@ -448,5 +448,5 @@
 PJ_DEF(void*) pjsip_hdr_clone( pj_pool_t *pool, const void *hdr_ptr )
 {
-    const pjsip_hdr *hdr = hdr_ptr;
+    const pjsip_hdr *hdr = (const pjsip_hdr *)hdr_ptr;
     return (*hdr->vptr->clone)(pool, hdr_ptr);
 }
@@ -455,5 +455,5 @@
 PJ_DEF(void*) pjsip_hdr_shallow_clone( pj_pool_t *pool, const void *hdr_ptr )
 {
-    const pjsip_hdr *hdr = hdr_ptr;
+    const pjsip_hdr *hdr = (const pjsip_hdr *)hdr_ptr;
     return (*hdr->vptr->shallow_clone)(pool, hdr_ptr);
 }
@@ -461,5 +461,5 @@
 PJ_DEF(int) pjsip_hdr_print_on( void *hdr_ptr, char *buf, pj_size_t len)
 {
-    pjsip_hdr *hdr = hdr_ptr;
+    pjsip_hdr *hdr = (pjsip_hdr *)hdr_ptr;
     return (*hdr->vptr->print_on)(hdr_ptr, buf, len);
 }
@@ -507,5 +507,5 @@
 			       const pj_str_t *hvalue)
 {
-    pjsip_generic_string_hdr *hdr = mem;
+    pjsip_generic_string_hdr *hdr = (pjsip_generic_string_hdr *)mem;
 
     init_hdr(hdr, PJSIP_H_OTHER, &generic_hdr_vptr);
@@ -567,5 +567,6 @@
 							   const pjsip_generic_string_hdr *rhs )
 {
-    pjsip_generic_string_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_generic_string_hdr *hdr = (pjsip_generic_string_hdr *)
+				     pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     return hdr;
@@ -596,5 +597,5 @@
 							    int value)
 {
-    pjsip_generic_int_hdr *hdr = mem;
+    pjsip_generic_int_hdr *hdr = (pjsip_generic_int_hdr *) mem;
 
     init_hdr(hdr, PJSIP_H_OTHER, &generic_int_hdr_vptr);
@@ -636,5 +637,6 @@
 					           const pjsip_generic_int_hdr *rhs)
 {
-    pjsip_generic_int_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_generic_int_hdr *hdr = (pjsip_generic_int_hdr *)
+				  pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     return hdr;
@@ -644,5 +646,6 @@
 							   const pjsip_generic_int_hdr *rhs )
 {
-    pjsip_generic_int_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_generic_int_hdr *hdr = (pjsip_generic_int_hdr *)
+				 pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     return hdr;
@@ -671,5 +674,5 @@
 							       const pj_str_t *hnames)
 {
-    pjsip_generic_array_hdr *hdr = mem;
+    pjsip_generic_array_hdr *hdr = (pjsip_generic_array_hdr *) mem;
 
     init_hdr(hdr, PJSIP_H_OTHER, &generic_array_hdr_vptr);
@@ -715,5 +718,6 @@
 {
     unsigned i;
-    pjsip_generic_array_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_generic_array_hdr *hdr = (pjsip_generic_array_hdr *)
+				   pj_pool_alloc(pool, sizeof(*hdr));
 
     pj_memcpy(hdr, rhs, sizeof(*hdr));
@@ -729,5 +733,6 @@
 						 const pjsip_generic_array_hdr *rhs)
 {
-    pjsip_generic_array_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_generic_array_hdr *hdr = (pjsip_generic_array_hdr *)
+				   pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     return hdr;
@@ -741,5 +746,5 @@
 						 void *mem )
 {
-    pjsip_accept_hdr *hdr = mem;
+    pjsip_accept_hdr *hdr = (pjsip_accept_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -765,5 +770,5 @@
 					       void *mem )
 {
-    pjsip_allow_hdr *hdr = mem;
+    pjsip_allow_hdr *hdr = (pjsip_allow_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -788,5 +793,5 @@
 					   void *mem )
 {
-    pjsip_cid_hdr *hdr = mem;
+    pjsip_cid_hdr *hdr = (pjsip_cid_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -822,5 +827,5 @@
 					     void *mem )
 {
-    pjsip_clen_hdr *hdr = mem;
+    pjsip_clen_hdr *hdr = (pjsip_clen_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -884,5 +889,5 @@
 					     void *mem )
 {
-    pjsip_cseq_hdr *hdr = mem;
+    pjsip_cseq_hdr *hdr = (pjsip_cseq_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -939,5 +944,6 @@
 						     const pjsip_cseq_hdr *rhs )
 {
-    pjsip_cseq_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_cseq_hdr *hdr = (pjsip_cseq_hdr *) 
+			  pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     return hdr;
@@ -963,5 +969,5 @@
 						   void *mem )
 {
-    pjsip_contact_hdr *hdr = mem;
+    pjsip_contact_hdr *hdr = (pjsip_contact_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1055,5 +1061,5 @@
 	return hdr;
 
-    hdr->uri = pjsip_uri_clone(pool, rhs->uri);
+    hdr->uri = (pjsip_uri*) pjsip_uri_clone(pool, rhs->uri);
     hdr->q1000 = rhs->q1000;
     hdr->expires = rhs->expires;
@@ -1066,5 +1072,6 @@
 				 const pjsip_contact_hdr *rhs)
 {
-    pjsip_contact_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_contact_hdr *hdr = (pjsip_contact_hdr *) 
+			     pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone(pool, &hdr->other_param, &rhs->other_param);
@@ -1092,5 +1099,5 @@
 					       void *mem )
 {
-    pjsip_ctype_hdr *hdr = mem;
+    pjsip_ctype_hdr *hdr = (pjsip_ctype_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1169,5 +1176,5 @@
 						   int value)
 {
-    pjsip_expires_hdr *hdr = mem;
+    pjsip_expires_hdr *hdr = (pjsip_expires_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1208,5 +1215,5 @@
 					     void *mem )
 {
-    pjsip_from_hdr *hdr = mem;
+    pjsip_from_hdr *hdr = (pjsip_from_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1227,5 +1234,5 @@
 					 void *mem )
 {
-    pjsip_to_hdr *hdr = mem;
+    pjsip_to_hdr *hdr = (pjsip_to_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1296,5 +1303,5 @@
     hdr->name = rhs->name;
     hdr->sname = rhs->sname;
-    hdr->uri = pjsip_uri_clone(pool, rhs->uri);
+    hdr->uri = (pjsip_uri*) pjsip_uri_clone(pool, rhs->uri);
     pj_strdup( pool, &hdr->tag, &rhs->tag);
     pjsip_param_clone( pool, &hdr->other_param, &rhs->other_param);
@@ -1307,5 +1314,6 @@
 				const pjsip_fromto_hdr *rhs)
 {
-    pjsip_fromto_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_fromto_hdr *hdr = (pjsip_fromto_hdr *) 
+			    pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone( pool, &hdr->other_param, &rhs->other_param);
@@ -1322,5 +1330,5 @@
 						   int value)
 {
-    pjsip_max_fwd_hdr *hdr = mem;
+    pjsip_max_fwd_hdr *hdr = (pjsip_max_fwd_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1348,5 +1356,5 @@
 							   int value )
 {
-    pjsip_min_expires_hdr *hdr = mem;
+    pjsip_min_expires_hdr *hdr = (pjsip_min_expires_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1382,5 +1390,5 @@
 					 void *mem )
 {
-    pjsip_rr_hdr *hdr = mem;
+    pjsip_rr_hdr *hdr = (pjsip_rr_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1402,5 +1410,5 @@
 					       void *mem )
 {
-    pjsip_route_hdr *hdr = mem;
+    pjsip_route_hdr *hdr = (pjsip_route_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1462,5 +1470,6 @@
 						   const pjsip_routing_hdr *rhs )
 {
-    pjsip_routing_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_routing_hdr *hdr = (pjsip_routing_hdr *)
+			     pj_pool_alloc(pool, sizeof(*hdr));
 
     init_hdr(hdr, rhs->type, rhs->vptr);
@@ -1474,5 +1483,6 @@
 							   const pjsip_routing_hdr *rhs )
 {
-    pjsip_routing_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_routing_hdr *hdr = (pjsip_routing_hdr *)
+			     pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone( pool, &hdr->other_param, &rhs->other_param);
@@ -1488,5 +1498,5 @@
 						   void *mem )
 {
-    pjsip_require_hdr *hdr = mem;
+    pjsip_require_hdr *hdr = (pjsip_require_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1511,5 +1521,5 @@
 							   int value )
 {
-    pjsip_retry_after_hdr *hdr = mem;
+    pjsip_retry_after_hdr *hdr = (pjsip_retry_after_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1535,5 +1545,5 @@
 						       void *mem )
 {
-    pjsip_supported_hdr *hdr = mem;
+    pjsip_supported_hdr *hdr = (pjsip_supported_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1557,5 +1567,5 @@
 							   void *mem )
 {
-    pjsip_unsupported_hdr *hdr = mem;
+    pjsip_unsupported_hdr *hdr = (pjsip_unsupported_hdr *) mem;
     
     PJ_UNUSED_ARG(pool);
@@ -1590,5 +1600,5 @@
 					   void *mem )
 {
-    pjsip_via_hdr *hdr = mem;
+    pjsip_via_hdr *hdr = (pjsip_via_hdr *) mem;
 
     PJ_UNUSED_ARG(pool);
@@ -1697,5 +1707,5 @@
 						   const pjsip_via_hdr *rhs )
 {
-    pjsip_via_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_via_hdr *hdr = (pjsip_via_hdr *) pj_pool_alloc(pool, sizeof(*hdr));
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone(pool, &hdr->other_param, &rhs->other_param);
@@ -1715,5 +1725,6 @@
     pj_str_t hvalue;
 
-    hvalue.ptr = pj_pool_alloc(pool, 10 +		/* code */
+    hvalue.ptr = (char*)
+		 pj_pool_alloc(pool, 10 +		/* code */
 				     host->slen + 2 +	/* host */
 				     text->slen + 2);	/* text */
@@ -1755,5 +1766,5 @@
 
     if (len) {
-	newdata = pj_pool_alloc(pool, len);
+	newdata = (char*) pj_pool_alloc(pool, len);
 	pj_memcpy(newdata, data, len);
     }
@@ -1797,5 +1808,5 @@
     pj_status_t status;
 
-    new_body = pj_pool_alloc(pool, sizeof(pjsip_msg_body));
+    new_body = (pjsip_msg_body*) pj_pool_alloc(pool, sizeof(pjsip_msg_body));
     PJ_ASSERT_RETURN(new_body, NULL);
 
@@ -1815,5 +1826,5 @@
     PJ_ASSERT_RETURN(pool && type && subtype && text, NULL);
 
-    body = pj_pool_zalloc(pool, sizeof(pjsip_msg_body));
+    body = (pjsip_msg_body*) pj_pool_zalloc(pool, sizeof(pjsip_msg_body));
     PJ_ASSERT_RETURN(body != NULL, NULL);
 
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_parser.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_parser.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_parser.c	(revision 789)
@@ -221,5 +221,5 @@
 
     len = param->slen + pname->slen + pvalue->slen + 3;
-    p = new_param = pj_pool_alloc(pool, len);
+    p = new_param = (char*) pj_pool_alloc(pool, len);
     
     if (param->slen) {
@@ -887,5 +887,6 @@
 	 */
 	if (ctype_hdr && scanner->curptr!=scanner->end) {
-	    pjsip_msg_body *body = pj_pool_alloc(pool, sizeof(pjsip_msg_body));
+	    pjsip_msg_body *body = (pjsip_msg_body *) 
+				   pj_pool_alloc(pool, sizeof(pjsip_msg_body));
 	    body->content_type.type = ctype_hdr->media.type;
 	    body->content_type.subtype = ctype_hdr->media.subtype;
@@ -907,5 +908,6 @@
 	    pjsip_parser_err_report *err_info;
 	    
-	    err_info = pj_pool_alloc(pool, sizeof(*err_info));
+	    err_info = (pjsip_parser_err_report *) 
+		       pj_pool_alloc(pool, sizeof(*err_info));
 	    err_info->except_code = PJ_GET_EXCEPTION();
 	    err_info->line = scanner->line;
@@ -1096,5 +1098,6 @@
 	    }
 
-	    uri = (*func)( scanner, pool, 
+	    uri = (pjsip_uri*)
+		  (*func)( scanner, pool, 
 			  (opt & PJSIP_PARSE_URI_IN_FROM_TO_HDR)== 0);
 
@@ -1217,5 +1220,6 @@
 
 	} else {
-	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    pjsip_param *p = (pjsip_param *) 
+			     pj_pool_alloc(pool, sizeof(pjsip_param));
 	    p->name = pname;
 	    p->value = pvalue;
@@ -1229,5 +1233,5 @@
       do {
 	pjsip_param *param;
-	param = pj_pool_alloc(pool, sizeof(pjsip_param));
+	param = (pjsip_param *) pj_pool_alloc(pool, sizeof(pjsip_param));
 	int_parse_hparam(scanner, pool, &param->name, &param->value);
 	pj_list_insert_before(&url->header_param, param);
@@ -1417,5 +1421,5 @@
 	int_parse_param( scanner, pool, &pname, &pvalue);
 	if (!parser_stricmp(pname, pjsip_Q_STR) && pvalue.slen) {
-	    char *dot_pos = memchr(pvalue.ptr, '.', pvalue.slen);
+	    char *dot_pos = (char *) memchr(pvalue.ptr, '.', pvalue.slen);
 	    if (!dot_pos) {
 		hdr->q1000 = pj_strtoul(&pvalue);
@@ -1429,5 +1433,6 @@
 
 	} else {
-	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    pjsip_param *p = (pjsip_param *) 
+			     pj_pool_alloc(pool, sizeof(pjsip_param));
 	    p->name = pname;
 	    p->value = pvalue;
@@ -1567,5 +1572,6 @@
 	    
 	} else {
-	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    pjsip_param *p = (pjsip_param *) 
+			     pj_pool_alloc(pool, sizeof(pjsip_param));
 	    p->name = pname;
 	    p->value = pvalue;
@@ -1665,5 +1671,6 @@
 		hdr->rport_param = 0;
 	} else {
-	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    pjsip_param *p = (pjsip_param *) 
+			     pj_pool_alloc(pool, sizeof(pjsip_param));
 	    p->name = pname;
 	    p->value = pvalue;
@@ -1705,5 +1712,6 @@
 
     while (*scanner->curptr == ';') {
-	pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	pjsip_param *p = (pjsip_param *) 
+			 pj_pool_alloc(pool, sizeof(pjsip_param));
 	int_parse_param(scanner, pool, &p->name, &p->value);
 	pj_list_insert_before(&hdr->other_param, p);
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_tel_uri.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_tel_uri.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_tel_uri.c	(revision 789)
@@ -74,17 +74,22 @@
 				     pj_bool_t parse_params);
 
-#ifdef __GNUC__
-#  define HAPPY_FLAG	(void*)
-#else
-#  define HAPPY_FLAG
-#endif
+
+typedef const pj_str_t* (*FGETSCHEME)(const void *uri);
+typedef void* (*FGETURI)(void *uri);
+typedef pj_ssize_t (*FPRINT)(pjsip_uri_context_e context,
+			     const void *uri, 
+			     char *buf, pj_size_t size);
+typedef pj_status_t (*FCOMPARE)(pjsip_uri_context_e context, 
+				const void *uri1, const void *uri2);
+typedef void *(*FCLONE)(pj_pool_t *pool, const void *uri);
+
 
 static pjsip_uri_vptr tel_uri_vptr = 
 {
-    HAPPY_FLAG &tel_uri_get_scheme,
-    HAPPY_FLAG &tel_uri_get_uri,
-    HAPPY_FLAG &tel_uri_print,
-    HAPPY_FLAG &tel_uri_cmp,
-    HAPPY_FLAG &tel_uri_clone
+    (FGETSCHEME) &tel_uri_get_scheme,
+    (FGETURI)	 &tel_uri_get_uri,
+    (FPRINT)	 &tel_uri_print,
+    (FCOMPARE)   &tel_uri_cmp,
+    (FCLONE)	 &tel_uri_clone
 };
 
@@ -92,5 +97,6 @@
 PJ_DEF(pjsip_tel_uri*) pjsip_tel_uri_create(pj_pool_t *pool)
 {
-    pjsip_tel_uri *uri = pj_pool_zalloc(pool, sizeof(pjsip_tel_uri));
+    pjsip_tel_uri *uri = (pjsip_tel_uri *) 
+			 pj_pool_zalloc(pool, sizeof(pjsip_tel_uri));
     uri->vptr = &tel_uri_vptr;
     pj_list_init(&uri->other_param);
@@ -404,5 +410,6 @@
 		uri->context = pvalue;
 	    } else {
-		pjsip_param *param = pj_pool_alloc(pool, sizeof(pjsip_param));
+		pjsip_param *param = (pjsip_param *)
+				     pj_pool_alloc(pool, sizeof(pjsip_param));
 		param->name = pname;
 		param->value = pvalue;
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_transaction.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_transaction.c	(revision 789)
@@ -280,5 +280,5 @@
 		   9 +			    /* Via port. */
 		   16;			    /* Separator+Allowance. */
-    key = p = pj_pool_alloc(pool, len_required);
+    key = p = (char*) pj_pool_alloc(pool, len_required);
     end = p + len_required;
 
@@ -347,5 +347,6 @@
     PJ_ASSERT_RETURN(pool && key && method && branch, PJ_EINVAL);
 
-    p = key->ptr = pj_pool_alloc(pool, branch->slen + method->name.slen + 4 );
+    p = key->ptr = (char*) 
+		   pj_pool_alloc(pool, branch->slen + method->name.slen + 4 );
     
     /* Add role. */
@@ -581,5 +582,6 @@
 
     pj_mutex_lock(mod_tsx_layer.mutex);
-    tsx = pj_hash_get( mod_tsx_layer.htable, key->ptr, key->slen, &hval );
+    tsx = (pjsip_transaction*) 
+	  pj_hash_get( mod_tsx_layer.htable, key->ptr, key->slen, &hval );
     pj_mutex_unlock(mod_tsx_layer.mutex);
 
@@ -632,5 +634,6 @@
     it = pj_hash_first(mod_tsx_layer.htable, &it_buf);
     while (it) {
-	pjsip_transaction *tsx = pj_hash_this(mod_tsx_layer.htable, it);
+	pjsip_transaction *tsx = (pjsip_transaction *) 
+				 pj_hash_this(mod_tsx_layer.htable, it);
 	pj_hash_iterator_t *next = pj_hash_next(mod_tsx_layer.htable, it);
 	if (tsx)
@@ -679,5 +682,6 @@
     pj_mutex_lock( mod_tsx_layer.mutex );
 
-    tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
+    tsx = (pjsip_transaction *) 
+	  pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
 
 
@@ -727,5 +731,6 @@
     pj_mutex_lock( mod_tsx_layer.mutex );
 
-    tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
+    tsx = (pjsip_transaction *) 
+	  pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
 
 
@@ -765,5 +770,6 @@
 PJ_DEF(pjsip_transaction*) pjsip_rdata_get_tsx( pjsip_rx_data *rdata )
 {
-    return rdata->endpt_info.mod_data[mod_tsx_layer.mod.id];
+    return (pjsip_transaction *) 
+	   rdata->endpt_info.mod_data[mod_tsx_layer.mod.id];
 }
 
@@ -790,5 +796,6 @@
 	} else {
 	    while (it != NULL) {
-		pjsip_transaction *tsx = pj_hash_this(mod_tsx_layer.htable,it);
+		pjsip_transaction *tsx = (pjsip_transaction *)
+					 pj_hash_this(mod_tsx_layer.htable,it);
 
 		PJ_LOG(3, (THIS_FILE, " %s %s|%d|%s",
@@ -868,5 +875,5 @@
 	return PJ_ENOMEM;
 
-    tsx = pj_pool_zalloc(pool, sizeof(pjsip_transaction));
+    tsx = (pjsip_transaction*) pj_pool_zalloc(pool, sizeof(pjsip_transaction));
     tsx->pool = pool;
     tsx->tsx_user = tsx_user;
@@ -934,5 +941,5 @@
 
     /* Clear TLS, so that mutex will not be unlocked */
-    lck = pj_thread_local_get(pjsip_tsx_lock_tls_id);
+    lck = (struct tsx_lock_data *) pj_thread_local_get(pjsip_tsx_lock_tls_id);
     while (lck) {
 	if (lck->tsx == tsx) {
@@ -956,5 +963,5 @@
 {
     pjsip_event event;
-    pjsip_transaction *tsx = entry->user_data;
+    pjsip_transaction *tsx = (pjsip_transaction *) entry->user_data;
     struct tsx_lock_data lck;
 
@@ -1006,5 +1013,5 @@
      */
     if (event_src_type==PJSIP_EVENT_RX_MSG && tsx->tsx_user) {
-	pjsip_rx_data *rdata = event_src;
+	pjsip_rx_data *rdata = (pjsip_rx_data *) event_src;
 
 	pj_assert(rdata != NULL);
@@ -1087,5 +1094,5 @@
 
     /* Make sure CSeq header is present. */
-    cseq = pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
+    cseq = (pjsip_cseq_hdr*) pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
     if (!cseq) {
 	pj_assert(!"CSeq header not present in outgoing message!");
@@ -1113,5 +1120,5 @@
 
     /* Generate Via header if it doesn't exist. */
-    via = pjsip_msg_find_hdr(msg, PJSIP_H_VIA, NULL);
+    via = (pjsip_via_hdr*) pjsip_msg_find_hdr(msg, PJSIP_H_VIA, NULL);
     if (via == NULL) {
 	via = pjsip_via_hdr_create(tdata->pool);
@@ -1122,5 +1129,6 @@
     if (via->branch_param.slen == 0) {
 	pj_str_t tmp;
-	via->branch_param.ptr = pj_pool_alloc(tsx->pool, PJSIP_MAX_BRANCH_LEN);
+	via->branch_param.ptr = (char*)
+				pj_pool_alloc(tsx->pool, PJSIP_MAX_BRANCH_LEN);
 	via->branch_param.slen = PJSIP_MAX_BRANCH_LEN;
 	pj_memcpy(via->branch_param.ptr, PJSIP_RFC3261_BRANCH_ID, 
@@ -1418,5 +1426,5 @@
 			       pj_ssize_t sent, pj_bool_t *cont )
 {
-    pjsip_transaction *tsx = send_state->token;
+    pjsip_transaction *tsx = (pjsip_transaction *) send_state->token;
     struct tsx_lock_data lck;
 
@@ -1535,5 +1543,5 @@
 {
     if (sent < 0) {
-	pjsip_transaction *tsx = token;
+	pjsip_transaction *tsx = (pjsip_transaction *) token;
 	struct tsx_lock_data lck;
 	char errmsg[PJ_ERR_MSG_SIZE];
@@ -2117,5 +2125,6 @@
 	     */
 	    if (!tsx->is_reliable) {
-		pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ,
+		pjsip_cseq_hdr *cseq = (pjsip_cseq_hdr *) 
+				       pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ,
                                                            NULL);
 		if (cseq->method.id == PJSIP_INVITE_METHOD) {
